;*************************************************************************
; An 8051 Based Web Server
; keypad.a51: driver code for keypad
; By Mason Kidd 10/25/01
;*************************************************************************

$NOMOD51
$INCLUDE(reg515.inc)

name		keypad
public	kbdinit, keypadi, keypress

sd_keypad		SEGMENT	DATA
			RSEG sd_keypad

keypress:	DS	1
  			
sc_keypad		SEGMENT	CODE
			RSEG	sc_keypad
 		
			USING 0
               
kbdpt	equ	30h      	; value for P2 to access keyboard


kbdtbl: 
	db	'123C456D789EA0BF'

kbdinit:
	setb	IT1			; extern int 1 falling edge
	setb	EX1			; enable external interrupt
	ret

keypadi:
	push	acc
	push	psw
	push	dph
	push	dpl
	push	p2
	mov	dptr, #kbdtbl		; point to translation table
	mov	p2, #kbdpt		; point to keyboard
	movx	a, @r1
	anl	a, #00011111B		; mask lower 5 bits
	movc	a, @a+dptr		; translate to character code
	mov	keypress, A
	pop	p2
	pop	dpl
	pop	dph
	pop	psw
	pop	acc
	reti
     	
	end
