// ***************************************************************************
// An 8051 Based Web Server
// tcp.h: structures for tcp connections
// By Mason Kidd 3/28/02
// ***************************************************************************

#ifndef H__TCP
#define H__TCP

#define TCP_MAX_CONN 1

enum tcp_state
{
	LISTEN = 1,
	SYN_SENT,
	SYN_RECVD,
	ESTABLISHED,
	FIN_WAIT_1,
	FIN_WAIT_2,
	CLOSE_WAIT,
	CLOSING,
	LAST_ACK,
	TIME_WAIT,
	CLOSED
};

enum tcp_cntrl_flags
{
	TCP_CNTRL_FIN = 0x01,
	TCP_CNTRL_SYN = 0x02,
	TCP_CNTRL_RST = 0x04,
	TCP_CNTRL_PSH = 0x08,
	TCP_CNTRL_ACK = 0x10,
	TCP_CNTRL_URG = 0x20
};

struct tcp_TCB
{
	unsigned int local_port;		// Local port number
	unsigned int remote_port;	// Remote port number
	unsigned char remote_addr[4];	// Remote IP address
	unsigned char state;		// Our current state
	unsigned char local_seq;		// Local sequence number
	unsigned char remote_seq;	// Remote sequence number
};

#define TCP_PORT_HTTP 80

#define TCP_START_SEQ 1000

void tcp_init(void);
void rx_tcp_packet(unsigned char *rx_buffer);
void tx_tcp_packet(unsigned char current_TCB, unsigned char control_bits, unsigned char *szData, unsigned int nLength);

#endif

